unit Unit1;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, ComCtrls, Menus,
  StdCtrls, Dialogs;

type
  TFMain = class(TForm)
    Pole: TMemo;
    MainMenu1: TMainMenu;
    Plik1: TMenuItem;
    Nowy1: TMenuItem;
    Otwrz1: TMenuItem;
    Zapisz1: TMenuItem;
    Zapiszjako1: TMenuItem;
    N1: TMenuItem;
    Zakocz1: TMenuItem;
    Edycja1: TMenuItem;
    Wytnij1: TMenuItem;
    Kopiuj1: TMenuItem;
    Wklej1: TMenuItem;
    StatusBar1: TStatusBar;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    Cofnij1: TMenuItem;
    N2: TMenuItem;
    Oprogramie1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Nowy1Click(Sender: TObject);
    function Wyczysc: Boolean;
    procedure ZapiszOgolnie;
    procedure Zapisz;
    procedure ZapiszJako;
    procedure Otwrz1Click(Sender: TObject);
    procedure SetNazwa(n: TFileName);
    procedure Zapisz1Click(Sender: TObject);
    procedure Zapiszjako1Click(Sender: TObject);
    procedure Zakocz1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PoleChange(Sender: TObject);
    procedure Wytnij1Click(Sender: TObject);
    procedure Cofnij1Click(Sender: TObject);
    procedure Kopiuj1Click(Sender: TObject);
    procedure Wklej1Click(Sender: TObject);
    procedure Oprogramie1Click(Sender: TObject);
  private
  _Nazwa: TFileName;
    { Private declarations }
  public
  Gwiazdka: Boolean;
  property Nazwa: TFileName read _Nazwa write SetNazwa;
    { Public declarations }
  end;

var
  FMain: TFMain;

implementation

{$R *.dfm}

procedure TFMain.SetNazwa(n: TFileName);
var
s: String;
begin
if n=_Nazwa then exit;
if n='' then s:='' else s:='  '+ExtractFileName(n);
Application.Title:='Edytorix'+s;
Caption:=Application.Title;
_Nazwa:=n;
end;

procedure TFMain.FormCreate(Sender: TObject);
begin
Gwiazdka:=False;
Nazwa:='';
end;

procedure TFMain.Nowy1Click(Sender: TObject);
begin
Wyczysc;
end;

function TFMain.Wyczysc: Boolean;
var
w: Word;
begin
Result:=False;
if Gwiazdka then begin
   w:=MessageDlg('Zawarto zostaa zmieniona. Czy chcesz zapisa zmiany?',mtWarning,[mbYes,mbNo,mbCancel],0);
   case w of
        mrYes: ZapiszOgolnie;
        mrCancel: exit;
        end;
   Gwiazdka:=False;
   end;
Pole.Clear;
Pole.ClearUndo;
Nazwa:='';
Result:=True;
end;

procedure TFMain.ZapiszOgolnie;
begin
if Nazwa='' then ZapiszJako else Zapisz;
end;

procedure TFMain.Zapisz;
var
tf: TextFile;
s: String;
i,b: Integer;
begin
AssignFile(tf,Nazwa);
Rewrite(tf);
i:=0;
if Pole.Lines.Count>0 then while True do begin
    s:=Pole.Lines[i];
    if s<>'' then for b:=0 to Length(s) do case s[b] of
       #$A5: s[b]:=#$A1;
       #$8C: s[b]:=#$A6;
       #$8F: s[b]:=#$AC;
       #$B9: s[b]:=#$B1;
       #$9C: s[b]:=#$B6;
       #$9F: s[b]:=#$BC;
       end;
    Write(tf,s);
    if i>=Pole.Lines.Count-1 then break;
    Write(tf,#10);
    Inc(i);
    end;
CloseFile(tf);
Gwiazdka:=False;
end;

procedure TFMain.ZapiszJako;
begin
if not SaveDialog1.Execute then exit;
Nazwa:=SaveDialog1.FileName;
Zapisz;
end;

procedure TFMain.Otwrz1Click(Sender: TObject);
var
tf: TextFile;
s,t: String;
b: Integer;
begin
if not Wyczysc then exit;
if not OpenDialog1.Execute then exit;
Nazwa:=OpenDialog1.FileName;
AssignFile(tf,Nazwa);
Reset(tf);
t:='';
while not Eof(tf) do begin
      ReadLn(tf,s);
      if s<>'' then for b:=0 to Length(s) do case s[b] of
          #$A1: s[b]:=#$A5;
          #$A6: s[b]:=#$8C;
          #$AC: s[b]:=#$8F;
          #$B1: s[b]:=#$B9;
          #$B6: s[b]:=#$9C;
          #$BC: s[b]:=#$9F;
          end;
      if t<>'' then t:=t+#13#10;
      t:=t+s;
      end;
Pole.Text:=t;
Gwiazdka:=False;
CloseFile(tf);
end;

procedure TFMain.Zapisz1Click(Sender: TObject);
begin
ZapiszOgolnie;
end;

procedure TFMain.Zapiszjako1Click(Sender: TObject);
begin
ZapiszJako;
end;

procedure TFMain.Zakocz1Click(Sender: TObject);
begin
Close;
end;

procedure TFMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
if not Wyczysc then Action:=caNone;
end;

procedure TFMain.PoleChange(Sender: TObject);
begin
Gwiazdka:=True;
end;

procedure TFMain.Wytnij1Click(Sender: TObject);
begin
Pole.CutToClipboard;
end;

procedure TFMain.Cofnij1Click(Sender: TObject);
begin
Pole.Undo;
end;

procedure TFMain.Kopiuj1Click(Sender: TObject);
begin
Pole.CopyToClipboard;
end;

procedure TFMain.Wklej1Click(Sender: TObject);
begin
Pole.PasteFromClipboard;
end;

procedure TFMain.Oprogramie1Click(Sender: TObject);
begin
ShowMessage('Edytorix 1.0'#13#10#13#10'PieterSoft'#13#10'http://pieterer.freeshell.org/'#13#10'kontakt: pieterer@onet.pl');
end;

end.
